<h1 align="center">Dyatel Wrapper</h1>

<h2 align="center">Automation Beyond Limits</h2>

<p align="center">
    <a href="https://github.com/CustomEnv/dyatel/blob/master/LICENSE"><img alt="GitHub License" src="https://img.shields.io/github/license/CustomEnv/dyatel?logo=github&color=%234F2684&labelColor=%232E353B"></a>
    <a href="https://pypi.org/project/dyatel-wrapper/"><img alt="PyPI - Python Version" src="https://img.shields.io/pypi/pyversions/dyatel-wrapper?logo=pypi&labelColor=%232E353B"></a>
    <a href="https://pypi.org/project/dyatel-wrapper/"><img alt="PyPI - Version" src="https://img.shields.io/pypi/v/dyatel-wrapper?logo=pypi&labelColor=%232E353B"></a>
</p> 

<p align="center">
    <a href="https://dyatel-wrapper.readthedocs.io"><img alt="Documentation Status" src="https://img.shields.io/readthedocs/dyatel-wrapper?logo=readthedocs&labelColor=%232E353B&label=docs"></a>
    <a href="https://github.com/CustomEnv/dyatel/actions/workflows/static_tests.yml">
        <img alt="GitHub Actions Workflow Status" src="https://img.shields.io/github/actions/workflow/status/CustomEnv/dyatel/static_tests.yml?logo=github&label=Unit%20Tests&labelColor=%232E353B">
    </a>
    <a href="https://github.com/CustomEnv/dyatel/actions/workflows/playwright_tests.yml">
        <img alt="GitHub Actions Workflow Status" src="https://img.shields.io/github/actions/workflow/status/CustomEnv/dyatel/playwright_tests.yml?logo=github&label=Playwright%20Tests&labelColor=%232E353B">
    </a>
</p> 

<p align="center">
    <a href="https://github.com/CustomEnv/dyatel/actions/workflows/selenium_tests.yml">
        <img alt="GitHub Actions Workflow Status" src="https://img.shields.io/github/actions/workflow/status/CustomEnv/dyatel/selenium_tests.yml?logo=github&label=Selenium%20Tests&labelColor=%232E353B">
    </a>
    <a href="https://github.com/CustomEnv/dyatel/actions/workflows/selenium_safari_tests.yml">
        <img alt="GitHub Actions Workflow Status" src="https://img.shields.io/github/actions/workflow/status/CustomEnv/dyatel/selenium_safari_tests.yml?logo=github&label=Selenium%20Safari%20Tests&labelColor=%232E353B">
    </a>
    <a href="https://github.com/CustomEnv/dyatel/actions/workflows/appium_android_tests.yml">
        <img alt="GitHub Actions Workflow Status" src="https://img.shields.io/github/actions/workflow/status/CustomEnv/dyatel/appium_android_tests.yml?logo=github&label=Android%20Tests&labelColor=%232E353B">
    </a>
    <a href="https://github.com/CustomEnv/dyatel/actions/workflows/appium_ios_tests.yml">
        <img alt="GitHub Actions Workflow Status" src="https://img.shields.io/github/actions/workflow/status/CustomEnv/dyatel/appium_ios_tests.yml?logo=github&label=iOS%20Tests&labelColor=%232E353B">
    </a>
</p>


Dyatel Wrapper is a Python framework that seamlessly wraps over Selenium, Appium, and sync Playwright,
providing a unified interface for browser and mobile automation. With Dyatel Wrapper, you can effortlessly switch 
between these engines within the same test, allowing you to leverage the unique features of each framework without boundaries.

Whether you're running tests on web browsers, mobile devices, or a combination of both, Dyatel Wrapper simplifies the 
process, giving you the flexibility and power to automate complex testing scenarios with ease.

## Key Features

- **Seamless Integration**: Dyatel Wrapper integrates with Selenium, Appium, and Playwright, allowing you to use the best-suited engine for your specific testing needs.
- **Unified API**: A single, easy-to-use API that abstracts away the differences between Selenium, Appium, and Playwright, making your test scripts more readable and maintainable.
- **Engine Switching**: Switch between Selenium, Appium, and Playwright within the same test case, enabling cross-platform and cross-browser testing with minimal effort.
- **Visual Regression Testing**: Perform visual regression tests using the integrated visual regression tool, available across all supported frameworks. This ensures your UI remains consistent across different browsers and devices.
- **Advanced Features**: Leverage the advanced features of each framework, such as Playwright's mocks and Appium's real mobile devices support, all while using the same testing framework.
- **Extensibility**: Extend the framework with custom functionality tailored to your project's specific requirements.
- **Automatic Locator Type Definition**: The locator type will be automatically determined based on the provided locator string or `Locator` object.


## Installation and usage
For information on installation and usage, please refer to our **[ReadTheDocs documentation](https://dyatel-wrapper.readthedocs.io)**. Check it out for more details.


## Contributing

Dyatel Wrapper is an open-source project, and we welcome contributions from the community. If you'd like to contribute, please open an pull request from your fork

## License

Dyatel Wrapper is licensed under the Apache License. See the [LICENSE](https://github.com/CustomEnv/dyatel/blob/master/LICENSE) file for more details.

## Support

If you encounter any issues or have questions, please feel free to reach out via our [GitHub Issues](https://github.com/CustomEnv/dyatel/issues) page.

Thank you for choosing Dyatel Wrapper for your automation needs!
